Foreman - Refactor #13440

Replace Host::Base#model_name to prevent Rails 4.2 conflict
01/28/2016 10:07 AM - Dominic Cleal

Status: Closed
Priority: Normal
Assignee: Dominic Cleal
Category: Rails
Target version: 1.11.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3133
Description

Rails 4.2 implements #model_name in ActiveRecord::Base as an instance method rather than a class method (in 4.1 and older),
changed in https:/qgithub.com/rails/rails/commit/6b0e834.

Our HasManyCommon concern adds a model_name method to Host::Base as an extension of the model/model_id association to the
Model er, model. This will need to be removed to ensure the AR method continues to work.

When our model is in place, links to hosts can't be generated in Rails 4.2 as they return nil or string values from our implementation
Host::Base#model_name rather than the ActiveModel::Name object expected.

Related issues:

Related to Discovery - Bug #14227: Discovery mailer fails for hosts without m... Closed 03/16/2016
Related to Discovery - Refactor #14236: Rename model_name to hardware_model_name Duplicate 03/16/2016
Blocks Foreman - Feature #13244: Upgrade Ruby on Rails to 4.2 Closed 01/15/2016

Associated revisions

Revision 7¢671609 - 02/09/2016 04:29 AM - Dominic Cleal

fixes #13440 - rename Host#model_name to #hardware_model_name

Rails 4.2 defines a model_name instance method which is used in routing
and called from link_to. Rename our model_name methods to
hardware_model_name to prevent this overlapping and causing link_to
failures.

Host#hardware_model_name is provided as an equivalent getter to replace
it, and the #model_name= getter/setters are provided but are deprecated.
The deprecation period has been brought forward one release from the
usual, so as not to block an upgrade to Rails 4.2.

History

#1 - 01/28/2016 10:08 AM - Dominic Cleal
- Blocks Feature #13244: Upgrade Ruby on Rails to 4.2 added

#2 - 01/28/2016 10:53 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3133 added

#3 - 02/09/2016 05:01 AM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 7¢67160944db2904b06e10af24af1013f51810b0.
https://github.com/rails/rails/commit/6b0e834
https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/7c67160944db2904b06e10af24af1013f51810b0

#4 - 02/10/2016 09:40 AM - Dominic Cleal

- translation missing: en.field_release set to 71

#5 - 03/16/2016 09:17 AM - Dominic Cleal

- Related to Bug #14227: Discovery mailer fails for hosts without model name added

#6 - 03/16/2016 11:28 AM - Lukas Zapletal

- Related to Refactor #14236: Rename model_name to hardware_model name added
